////// Fragment Shader
precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform highp float iTime;
uniform highp vec2 inputSize;
uniform highp float scaleFactor;
uniform highp float seedFactor;

float random(float seed)
{
    return fract(sin(seed) * 43758.5453);
}
void main() {
    float scale = scaleFactor;
    float seed = iTime * seedFactor; // 调整乘数以控制随机性的速度
    float xOffset = (random(seed) - 0.5) * 2.0 * scale;
    float yOffset = (random(seed + 1.0) - 0.5) * 2.0 * scale;
    // 根据时间和坐标进行位移
    vec2 displacedCoord = textureCoordinate + vec2(xOffset, yOffset);
    displacedCoord = clamp(displacedCoord, 0.0, 1.0);
    gl_FragColor = texture2D(inputImageTexture, displacedCoord);
}